Bug 218645

Summary: [TextureMapper] The edges of blur backdrop-filter look gradient tranparent
Product: WebKit Reporter: Fujii Hironori <Hironori.Fujii>
Component: PlatformAssignee: Fujii Hironori <Hironori.Fujii>
Status: RESOLVED FIXED    
Severity: Normal CC: cgarcia, cmarcelo, don.olmstead, ews-watchlist, kondapallykalyan, luiz, magomez, webkit-bug-importer, zan
Priority: P2 Keywords: InRadar
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
test case
none
[Screenshot] GTK port
none
Patch
none
test case 2
none
WIP patch
none
Patch none

Description Fujii Hironori 2020-11-05 20:59:43 PST
Created attachment 413397 [details]
test case

[TextureMapper] blur backdrop-filter doesn't have correct outsets

The inside of box should be solid gray.
Comment 1 Fujii Hironori 2020-11-09 22:07:52 PST
css3/filters/backdrop/blur-input-bounds.html is a test case that is added by Bug 146215.
Comment 2 Fujii Hironori 2020-11-09 22:15:49 PST
Created attachment 413665 [details]
[Screenshot] GTK port
Comment 3 Fujii Hironori 2020-11-09 23:05:30 PST
Created attachment 413669 [details]
Patch
Comment 4 Miguel Gomez 2020-11-10 04:55:34 PST
I need to dig a bit deeper in the code to properly understand how backdrop-filters work and how they should work. I'll devote some time to this.

In the meanwhile, Fujii, did you see bug 217476? Concretely this test page https://hacktivis.me/tmp/webkit-backdrop-filter-header.xhtml

Checking against Chrome I see 2 things:

- The weird effect just below the rectangle, that happens when mixing the rectangle shadow with the text. Seems that instead of a uniform blur shadow, the shadow is using the underlying text to be calculated, as is it was a blur of the text. This is probably a different bug than this one.

- There's a small part at the left and top of the rectangle where the blur is not applied. It's easily visible if you scroll the text. This seems something similar to the issue you're trying to fix here, but it happens with your patch as well. What do you think?
Comment 5 Fujii Hironori 2020-11-10 12:24:54 PST
I didn't know the bug. Thank you.

The second problem is that backdrop-filter block is placed in the
top left corner but the root layer doesn't render the outside of
screen into the intermediate surface. I should take the same
extrapolating approach like Cocoa port.

The first problem is interesting, but I don't figure out. I will
check it.
Comment 6 Fujii Hironori 2020-11-10 16:36:21 PST
Created attachment 413757 [details]
test case 2
Comment 7 Radar WebKit Bug Importer 2020-11-12 21:01:40 PST
<rdar://problem/71356999>
Comment 8 Fujii Hironori 2020-11-15 18:12:53 PST
Created attachment 414188 [details]
WIP patch
Comment 9 Fujii Hironori 2020-11-15 20:11:30 PST
Created attachment 414190 [details]
Patch
Comment 10 EWS 2020-11-16 00:20:02 PST
Committed r269837: <https://trac.webkit.org/changeset/269837>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 414190 [details].